//audio
datablock AudioProfile(autoscattershotSound)
  {
     filename = "./SND/autoscatterShot.wav";
     description = AudioDefault3d;
     preload = false;
  };

//projetil
AddDamageType("Autoscatter",   '<bitmap:add-ons/Weapon_Autoscatter/IMG/CI_autoscatter> %1',    '%2 <bitmap:add-ons/Weapon_Autoscatter/IMG/CI_autoscatter> %1',0.2,1);
datablock ProjectileData(autoscatterProjectile : gunProjectile)
{
   directDamage        = 15;
   directDamageType    = $DamageType::Autoscatter;
   radiusDamageType    = $DamageType::Autoscatter;

   isBallistic         = true;
   gravityMod = 0.1;
};

//////////
// item //
//////////
datablock ItemData(AutoscatterItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MDL/Autoscatter.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Autoscatter";
	iconName = "./IMG/icon_Autoscatter";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = AutoscatterImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(AutoscatterImage)
{
   // Basic Item properties
   shapeFile = "./MDL/Autoscatter.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = AutoscatterProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0 0.0";
	shellExitVariance   = 2.0;	
	shellVelocity       = 8.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = AutoscatterItem.colorShiftColor;//"0.400 0.196 0 1.000";

   raycastWeaponRange = 12; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
// raycastExplosionProjectile = GunProjectile;
// raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 25;
   raycastDirectDamageType = $DamageType::Autoscatter;
   raycastSpreadAmt = 0; //varies
   raycastSpreadCount = 1;
//  raycastTracerProjectile = ;
   raycastFromMuzzle = true;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.4;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.17;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= autoscatterShotSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateScript[3] = "onSmoke";
	stateTimeoutValue[3]            = 0.02;
	stateTransitionOnTimeout[3]     = "Wait";
	stateSequence[3]	= "Ready";
	
	stateName[4] = "Wait";
	stateAllowImageChange[4] = true;
	stateTransitionOnTriggerUp[4] = "Ready";

};

function AutoscatterImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, shiftRight);
	%obj.playThread(0, shiftLeft);
	Parent::onFire(%this,%obj,%slot);

	%projectile = AutoscatterProjectile;
	%spread = 0.003;
	%shellcount = 6;
            		
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}	
}

function AutoscatterImage::onSmoke(%this,%obj,%slot)
{
	%obj.playThread(0, plant);
//	%obj.playThread(2, plant);
}